
// marker_recogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "marker_recog.h"
#include "marker_recogDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Cmarker_recogDlg dialog

Cmarker_recogDlg::Cmarker_recogDlg(CWnd *pParent /*=NULL*/)
	: CDialog(Cmarker_recogDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	_camera = NULL;
	_markRecog = NULL;
}

void Cmarker_recogDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(Cmarker_recogDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// Cmarker_recogDlg message handlers

BOOL Cmarker_recogDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	GetDlgItem(IDC_STATIC_IMAGE)->GetWindowRect(&_dispRect);
	GetDlgItem(IDC_STATIC_IMAGE)->DestroyWindow();
	ScreenToClient(&_dispRect);

	_camera = new CCamOpenCV();
	_markRecog = new CMarkerDetection (0.146f, 0.146f);

	SetTimer(1000, 30, 0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cmarker_recogDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cmarker_recogDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void Cmarker_recogDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (_camera) {				
		IplImage *img = _camera->CaptureImage();	
		if (img) {
			//  ڽ ̹ ...
			//cvSet (img, CV_RGB(255,255,255));
			//cvDrawRect(img, cvPoint(100, 100), cvPoint (200,200), CV_RGB(0,0,0), CV_FILLED);

			IplImage *dst = cvCreateImage (cvGetSize(img), IPL_DEPTH_8U, 3);
			cvCopy(img, dst, 0);

			_markRecog->MarkerRecog(img, dst);

			CDC *pDC = GetDC();

			StretchDIBits(pDC->m_hDC, 
				_dispRect.left, _dispRect.top, _dispRect.Width(), _dispRect.Height(), 
				0, 0, _dispRect.Width(), _dispRect.Height(),
				(BYTE *)dst->imageData, _camera->GetBitmapInfo(), DIB_RGB_COLORS, SRCCOPY);

			ReleaseDC(pDC);

			cvReleaseImage(&dst);
		}
	}

	if (_markRecog->_markers.size()) {
		DrawMarkerAxis (_markRecog->_markers[0]);
	}

	CDialog::OnTimer(nIDEvent);
}

void Cmarker_recogDlg::OnDestroy()
{
	CDialog::OnDestroy();

	if(_camera) delete _camera;
	if(_markRecog) delete _markRecog;
}

#define M_PI	(3.14159265359)

void Cmarker_recogDlg::DrawMarkerAxis (sMarkerInfo &mi)
{
	// ī޶ ġ ȯ
	double _camera_pos[3] = {0, 0, 0 };
	double _camera_rot	  = 0;

	double x     =  -mi.translation[0];
	double y     =  -mi.translation[1];
	double z	 =  -mi.translation[2];
	double theta =  mi.rotation[2];
	double cos_th = cos(-theta);
	double sin_th = sin(-theta);

	_camera_pos[0] = cos_th*x - sin_th*y;
	_camera_pos[1] = sin_th*x + cos_th*y;
	_camera_pos[2] = z;
	_camera_rot	   = M_PI - theta;

	char text[1024*2];
	sprintf (text, 
		"Marker ID = %d\r\n"
		"\r\n"
		"Marker = %8.3f, %8.3f, %8.3f (%8.0f) \r\n"
		"\r\n"
		"Camera = %8.3f, %8.3f, %8.3f (%8.0f) \r\n",
		(int)mi.ID,
		(double)mi.translation[0], (double)mi.translation[1], (double)mi.translation[2], (double)mi.rotation[2]*180/M_PI, 
		_camera_pos[0], _camera_pos[1], _camera_pos[2], _camera_rot*180/M_PI);
	
	SetDlgItemText (IDC_EDIT_RESULT, text);
}
